From a020d10143b6e2f5b1efbdfc6bc3c10af97e4d42 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 18 2020 19:04:18 +0000
Subject: [PATCH 1740/2232] Consider mut receiver for allowing mut C++ return type


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 3b7b513..03b4724 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -464,6 +464,12 @@ fn check_mut_return_restriction(cx: &mut Check, efn: &ExternFn) {
         _ => return,
     }
 
+    if let Some(r) = &efn.receiver {
+        if r.mutable {
+            return;
+        }
+    }
+
     for arg in &efn.args {
         if let Type::Ref(ty) = &arg.ty {
             if ty.mutable {

